/*
 * RoundButton.java
 */

package th.ac.chula.eng.cp.pm;

import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;

/*
 * class Ѻٻҧٻǧ DS(顴лǧҴաͧ)
*/

public class RoundButton extends JButton {
    
	public RoundButton(String label) {
		super(label);

		// 駤ٻҧͧٻǧ ¡˹ٻҧǧդǢͧ᡹ͧҡѹ
		Dimension size = getPreferredSize();
		size.width = size.height = Math.max(size.width, size.height);
		setPreferredSize(size);

		// ӡ paint background ҹͧ͡ٻǧ öӡ paint background ͧٻǧ
		setContentAreaFilled(false);
	}

	// ӡҴ background  label ͧ
	protected void paintComponent(Graphics g) {
		if (getModel().isArmed()) {
			// ѺóշҨеͧբͧ繤سѵԢͧ class RoundButton
			g.setColor(Color.lightGray);
		} else {
			g.setColor(getBackground());
		}
		g.fillOval(0, 0, getSize().width - 1, getSize().height - 1);
		// ӡҴ
		super.paintComponent(g);
	}

	// Ҵͺͧ
	protected void paintBorder(Graphics g) {
		g.setColor(getForeground());
		g.drawOval(0, 0, getSize().width - 1, getSize().height - 1);
	}

	// ǹѺԨóһ١
	Shape shape;

	public boolean contains(int x, int y) {
		// ӡҧ object shape ҡա¹Ҵͧ 仵Ҵͧ㹻Ѩغѹ
		if (shape == null || !shape.getBounds().equals(getBounds())) {
			shape = new Ellipse2D.Float(0, 0, getWidth(), getHeight());
		}
		return shape.contains(x, y);
	}

	// method  run ͷͺ١ͧͧ class RoundButton
	public static void main(String[] args) {
		// ҧǧ label  "Jackpot".
		JButton button = new RoundButton("Jackpot");
		button.setBackground(Color.green);

		// ҧ JFrame ʴٻǧҧ
		JFrame frame = new JFrame();
		frame.getContentPane().setBackground(Color.yellow);
		frame.getContentPane().add(button);
		frame.getContentPane().setLayout(new FlowLayout());
		frame.setSize(150, 150);
		frame.setVisible(true);
	}
}
