/*
 * DSWindow.java
 *
 * Created on 4 Ҥ 2549, 2:01 .
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package th.ac.chula.eng.cp.pm;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.MediaTracker;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Random;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;


public class DSWindow extends JFrame {
    
    JPanel dpadPanel;
    
    JPanel leftMostPanel, leftPanel, middlePanel, rightPanel, rightMostPanel;
    
    JPanel roundButtonPanel, screenPanel, topScreenPanel;
    
    JPanel startPanel, selectPanel, lowerHalf, upperHalf, allPanel;
    
    JButton start, select, up, down, left, right;
    
    BouncingControlButton topLeftButton, bottomLeftButton,
            middleButton, topRightButton, bottomRightButton;
    
    BouncingControlActionListener listener = null;
    
    RoundButton a, b;
    
    private boolean firstTime = true;
    
    th.ac.chula.eng.cp.pm.RoundButton x, y;
    
    JLabel score, life;
    
    GameManager gameManager;
    
    BouncingComponent[] bouncingComponents;
    
    public DSWindow() {// Window ѡͧ 觨 Panel 
        super();
        
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        // add all panels together (collecting all of them on "allPanel") to form a complete dual screen 10 mins
        allPanel = getAllPanel();
        getContentPane().add(allPanel);
        
        setPreferredSize(new Dimension(350,350));
        pack();
        setVisible(true);
        setResizable(false);
        
    }
    
    //Method  Return AllPanel  AllPanel 觻Сͺ仴  UpperHalfPanel( Panel ҧҹըͧ) 
    // LowerHalfPanel ( Panel ҧҹҧջ ٻҾ١ͧ  ҧҹ)
    private JPanel getAllPanel(){
        if(allPanel == null){
            allPanel = new JPanel();
            allPanel.setLayout(new BoxLayout(allPanel, BoxLayout.Y_AXIS));
            allPanel.add(Box.createVerticalStrut(30));
            allPanel.add(getUpperHalfPanel());
            allPanel.add(Box.createVerticalStrut(5));
            allPanel.add(getLowerHalfPanel());
            
        }
        return allPanel;
    }
    
    //getUpperHalfPanel  Method  Return  UpperHaftPanel  Panel è TopScreenPanel(ͧ)
    // creates the upper parts of Nintendo DS
    private JPanel getUpperHalfPanel(){
        if(upperHalf == null){
            upperHalf = new JPanel();
            upperHalf.setAlignmentX(CENTER_ALIGNMENT);
            upperHalf.setLayout(new BoxLayout(upperHalf, BoxLayout.X_AXIS));
            upperHalf.add(getTopScreenPanel());
        }
        return upperHalf;
    }
    
    
    //getTopScreenPanel  Method  Return topScreenPanel  ӡõ駤Ҩͧº  Ҵ 
    private JPanel getTopScreenPanel(){
        if(topScreenPanel == null){
            topScreenPanel = new JPanel();
            topScreenPanel.setLayout(null);
            //168,117 300,150
            topScreenPanel.setPreferredSize(new Dimension(168, 117));
            topScreenPanel.setMaximumSize(new Dimension(168, 117));
            topScreenPanel.setMinimumSize(new Dimension(168, 117));
            topScreenPanel.setBackground(Color.YELLOW);
            topScreenPanel.setDoubleBuffered(true);
        }
        return topScreenPanel;
    }
    
    //getLowerHaftPanel  Method  Return lowerHaft Panel  Panel è 
    //LeftMostPanel  ScreenPanel  RightMostPanel 
    public JPanel getLowerHalfPanel(){
        if(lowerHalf == null){
            lowerHalf = new JPanel();
            lowerHalf.setLayout(new BoxLayout(lowerHalf, BoxLayout.X_AXIS));
            lowerHalf.add(getLeftMostPanel());
            lowerHalf.add(getScreenPanel());
            lowerHalf.add(Box.createHorizontalStrut(10));
            lowerHalf.add(getRightMostPanel());
            
        }
        return lowerHalf;
    }
    
    // getLeftMostPanel  Method  Return LeftMostPanel  Panel è DPadPanel
    // Set up the left most panel 5 mins
    private JPanel getLeftMostPanel(){
        if(leftMostPanel == null){
            // ҧ panel 㹹
        }
        return leftMostPanel;
    }
    
    //getDPadPanel  Method  Return DPadPanel  Panel èػ  ҧ  
    // Set up the left most panel 10 mins
    private JPanel getDPadPanel() {
        if(dpadPanel == null){
            // ҧ panel 㹹
        }
        
        return dpadPanel;
    }
    
    //getScreenPanel  Panel  Return ScreenPanel  Panel 繨ǹҧͧͧ DS ǹ
    //ʴҾ١ͧ1Ҿçҧ ӹҹԵ  ṹ
    // creates lower parts of Nintendo DS
    public JPanel getScreenPanel(){
        if(screenPanel == null){
            screenPanel = new JPanel();
            screenPanel.setBackground(Color.YELLOW);
            screenPanel.setLayout(new BoxLayout(screenPanel,BoxLayout.X_AXIS));
            screenPanel.add(getLeftPanel());
            screenPanel.add(getMiddlePanel());
            screenPanel.add(getRightPanel());
        }
        return screenPanel;
    }
    
    
    //getLeftPanel  Method  Return LeftPanel  Panel èҾҧҹ¢ͧҧ DS 2 Ҿ
    // picture panel - with fork and jug button 7 minutes
    private JPanel getLeftPanel(){
        if(leftPanel == null){
            // ҧ panel 㹹
        }
        return leftPanel;
    }
    
    //getMiddlePanel  Method  Return Middle Panel  Panel è ӹǹԵ ٻҾ Фṹͧҧ DS
    // set up panelMiddle 10 minutes
    private JPanel getMiddlePanel(){
        if(middlePanel == null){
            // ҧ panel 㹹
        }
        return middlePanel;
    }
    
    //getRightPanel  Panel  Return Right Panel  Panel èٻҾ١ͧ 2 ٻҧҹҢͧҧDS    
    private JPanel getRightPanel(){
        if(rightPanel == null){
            rightPanel = new JPanel();
            rightPanel.setMaximumSize(new Dimension(56, 117));
            rightPanel.setMinimumSize(new Dimension(56, 117));
            
            topRightButton = new BouncingControlButton();
            topRightButton.setMinimumSize(new Dimension(56, 56));
            topRightButton.setMaximumSize(new Dimension(56, 56));
            
            bottomRightButton = new BouncingControlButton();
            bottomRightButton.setMinimumSize(new Dimension(56, 56));
            bottomRightButton.setMaximumSize(new Dimension(56, 56));
            
            rightPanel.setLayout(new BoxLayout(rightPanel, BoxLayout.Y_AXIS));
            rightPanel.add(topRightButton);
            rightPanel.add(Box.createVerticalStrut(5));
            rightPanel.add(bottomRightButton);
            rightPanel.setBackground(Color.YELLOW);
        }
        return rightPanel;
    }
    
    //getRightMostPanel  Method  Return Right Panel  Panel èػ 4 л Start ҧҹҧ
    // set up rightmost panel - done for you
    private JPanel getRightMostPanel(){
        if(rightMostPanel == null){
            rightMostPanel = new JPanel();
            rightMostPanel.setMaximumSize(new Dimension(80, 117));
            rightMostPanel.setMinimumSize(new Dimension(80, 117));
            
            rightMostPanel.setLayout(new BoxLayout(rightMostPanel, BoxLayout.Y_AXIS));
            
            rightMostPanel.add(Box.createVerticalStrut(10));
            rightMostPanel.add(getRoundButtonPanel());
            
            
            rightMostPanel.add(getStartPanel());
            rightMostPanel.add(Box.createVerticalStrut(5));
            
        }
        
        return rightMostPanel;
    }
    
    //getRoundButtonPanel  Method  Return roundButtonPanel  Panel è 4 ǧҴҹҧ
    private JPanel getRoundButtonPanel(){
        if(roundButtonPanel == null){
            roundButtonPanel = new JPanel();
            roundButtonPanel.setPreferredSize(new Dimension(80, 57));
            roundButtonPanel.setLayout(new GridLayout(3, 3));
            
            x = new RoundButton("X");
            y = new RoundButton("Y");
            a = new RoundButton("A");
            b = new RoundButton("B");
            
            for (int i = 0; i <= 8; i++) {
                if (i == 1)
                    roundButtonPanel.add(x);
                else if (i == 3)
                    roundButtonPanel.add(a);
                else if (i == 5)
                    roundButtonPanel.add(y);
                else if (i == 7)
                    roundButtonPanel.add(b);
                else {
                    roundButtonPanel.add(Box.createRigidArea(new Dimension(5, 5)));
                    
                }
            }
        }
        return roundButtonPanel;
    }
    
    //getStartPanel  Return StartPanel  Panel è 2 ǧҧҹҧ 
    private JPanel getStartPanel(){
        if(startPanel == null){
            startPanel = new JPanel();
            startPanel.setLayout(new GridLayout(3, 8));
            start = new RoundButton("");
            select = new RoundButton("");
            
            for (int i = 0; i <= 23; i++) {
                if (i == 17)
                    startPanel.add(start);
                if (i == 15)
                    startPanel.add(select);
                else {
                    startPanel.add(Box.createRigidArea(new Dimension(0, 0)));
                }
            }
            
            start.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    startButtonActionPerformed(e);
                }
            });
        }
        return startPanel;
    }
    
    
   
    //Class Listener Ѵ˵ءóԴ͡Ҿҧͧ DS
    private class BouncingControlActionListener implements ActionListener{
        
        public void actionPerformed(ActionEvent e) {
            
            // Ե implement method ó            
        }
    }
    
    // Method зӧҹ͡ Start
    public void startButtonActionPerformed(ActionEvent e){
        
        // Ե implement method ó       
        
    }
    
    // Method ҧóԵөҡͧŴʴź˹Ҩͷѹ
    private void loadCurrentStage(StageLevel currentStageLevel) throws InterruptedException {
        
        life.setText("life : "+gameManager.getLife());
        score.setText("score : "+gameManager.getScore());
        
        ImageIcon[] colorIcons = currentStageLevel.getColoredIcons();
        ImageIcon[] shadowIcons = currentStageLevel.getShadowedIcons();
        
        listener = new BouncingControlActionListener();
        MediaTracker tracker = null;
        int id = 0;
        
        bouncingComponents = new BouncingComponent[shadowIcons.length];
        Random rand = new Random(System.nanoTime());
        for(int i=0;i<shadowIcons.length;i++){
            if(shadowIcons[i] != null){
                bouncingComponents[i] = new BouncingComponent();
                bouncingComponents[i].setShadowedIcon(shadowIcons[i]);
                if(colorIcons != null && colorIcons.length > i)
                    bouncingComponents[i].setColoredIcon(colorIcons[i]);
                bouncingComponents[i].setBounds(new Rectangle(
                        rand.nextInt(topScreenPanel.getWidth()-shadowIcons[i].getIconWidth())
                        ,rand.nextInt(topScreenPanel.getHeight()-shadowIcons[i].getIconHeight())
                        ,shadowIcons[i].getIconWidth()
                        ,shadowIcons[i].getIconHeight()));
                
                bouncingComponents[i].showShadowedIcon();
                
                topScreenPanel.add(bouncingComponents[i]);
                bouncingComponents[i].setBouncingBound(topScreenPanel.getWidth(),topScreenPanel.getHeight());
                int dif = currentStageLevel.maxSpeed - currentStageLevel.minSpeed;
                
                int x_speed = rand.nextInt(dif)+currentStageLevel.minSpeed;
                int y_speed = rand.nextInt(dif)+currentStageLevel.minSpeed;
                
                bouncingComponents[i].setSpeed(x_speed,y_speed);
                bouncingComponents[i].start();
                
                tracker = new MediaTracker(bouncingComponents[i]);
                tracker.addImage(shadowIcons[i].getImage(),++id);
                tracker.waitForAll();
            }
        }
        
        
        
        BouncingControlButton[] bouncingController = new BouncingControlButton[5];
        bouncingController[0] = topLeftButton;
        bouncingController[1] = bottomLeftButton;
        bouncingController[2] = middleButton;
        bouncingController[3] = topRightButton;
        bouncingController[4] = bottomRightButton;
        
        
        for(int i=0;i<colorIcons.length;i++){
            bouncingController[i].setIcon(colorIcons[i]);
            bouncingController[i].addActionListener(listener);
            bouncingController[i].setBouncingComponent(bouncingComponents[i]);
            bouncingController[i].setEnabled(true);
            tracker = new MediaTracker(bouncingController[i]);
            tracker.addImage(colorIcons[i].getImage(),++id);
            tracker.waitForAll();
        }
    }
    
    // Method źٻҾ͡ҡʹҹͧ DS
    private void removeBouncingComponents() {
        
        // Ե implement method ó
    }
    
    /**
     * @param args
     */
    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                new DSWindow().setVisible(true);
            }
        });
    }
}

