/*
 * StageLevel.java
 *
 * Created on 5 Ҥ 2549, 14:04 .
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package th.ac.chula.eng.cp.pm;

import java.util.HashSet;
import java.util.Map;
import java.util.Random;

import javax.swing.ImageIcon;

/*
 *ҹͧѡ㹡͡ٻҢʴ
 */
public class RandomIconStage extends StageLevel {

	//array ٻ⨷ҷ ٻ⨷ҹդ index 㹵˹ǡѺ ٻ͡ (ٻ)
    ImageIcon[] randomedShadowIcons;    
	//ҵðҹͧӹǹٻ⨷ҷҡش
    int maxRandom = 3;
    
    /** Creates a new instance of StageLevel */
	//constructor method ѺҤҡ, ٻ͡-ٻ⨷, ӹǹٻ⨷ҷҡش
    public RandomIconStage(int difficulty,Map itemMap,int maxRandom) {
        super(difficulty,itemMap);        
        
        if(maxRandom > itemMap.size())
            throw new IllegalArgumentException("maxRandom should not exceed itemMap size : "+ maxRandom +" > "+itemMap.size());
        
        this.maxRandom = maxRandom;
		//¡ method Ѻ駤鹷ͧҹ
        initialize();
    }
    

    //׹ array ͧٻ͡շ
    public ImageIcon[] getColoredIcons() {
        ImageIcon[] icons = new ImageIcon[itemMap.size()];
        itemMap.keySet().toArray(icons);
        return icons;
    }
    
	//׹ array ͧٻ⨷ҷ
    public ImageIcon[] getShadowedIcons() {        
        return randomedShadowIcons;
    }

    //׹  ٻ͡١͡ ⨷
	//ըФ׹ true ͡ҡٻ⨷ѧ١͡
    public boolean select(ImageIcon cIcon){
        ImageIcon sIcon = (ImageIcon) itemMap.get(cIcon);
        return unSelectedIcons.remove(sIcon);
    }
    
	//׹ ҹ鹨ѧ ´٨ҡҴͧٻ⨷ѧ١͡
    public boolean complete() {
        return unSelectedIcons.size() == 0;
    }
    
	//method 駤鹢ͧҹ
    private void initialize() {
        
		//ҧ randomedShadowIcons բҴҡѺӹǹٻ͡
        randomedShadowIcons = new ImageIcon[itemMap.size()];
        
        ImageIcon[] colorIcons = getColoredIcons();
        
        Random rand = new Random(System.currentTimeMillis());
        int i = 0,n = 0;
        unSelectedIcons = new HashSet(maxRandom);
        ImageIcon sIcon = null;

		//ٻ⨷ randomedShadowIcons unSelectedIcons
        while(i<maxRandom){
			//˹ٻբ˹觤
            n = rand.nextInt(colorIcons.length);
			//ҵ˹觹¶١ǹ ѧ͡ٻ⨷ҷ١ѹ randomedShadowIcons  unselectedIcons
            if(colorIcons[n]!=null){
                sIcon = (ImageIcon) itemMap.get(colorIcons[n]);
                randomedShadowIcons[n] = sIcon;
                unSelectedIcons.add(sIcon);
                colorIcons[n] = null;
                i++;
            }
        }        
    }
    
}
